/*
  Copyright (C) 2000 Xavier Hosxe <xhosxe@free.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __DIAMOND__
#define __DIAMOND__


#include <stdlib.h>
#include "sprite.hpp"
#include "list.hpp"
#include "myship.hpp"

class Diamond : public Sprite {
public:
    Diamond(Sprite *sprite);
    void draw();
    void drawShadowable();
    void move();
    void collision(Sprite *);
    static void initList();
    enum Type {
        POWER=0,
        BOMB=1,
        POWERUP=2,
        INVUL=3,
	} ;
    Type getType() {
        return type_;
    }
protected:
    float tetay_;
    float dtetay_;
    static int list_;
    Type type_;
    float sizePowerUp_;
};

#endif



