/*
   Copyright (C) 2000 Xavier Hosxe <xhosxe@free.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



#ifndef _ELEMENT_
#define _ELEMENT_

#include <stdlib.h>

class List;

class Elem {
    friend class List;
    friend class ListSprite;
protected:
    List *mlist;
    Elem *mprev;
    Elem *mnext;
public:
    Elem(List *list) {  mlist=list;  mprev=NULL;  mnext=NULL; }
    virtual ~Elem() {}
    Elem *GetNext(void) { return mnext; }
    Elem *GetPrev(void) { return mprev; }
    void SetNext(Elem *el)  { mnext = el; }
    void SetPrev(Elem *el)  { mprev = el; }
    void RemoveMe(void)  ;
    List* getList() { return mlist; }
};

#endif

