/*
  Copyright (C) 2000 Xavier Hosxe <xhosxe@free.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef _LIST_
#define _LIST_

#include <stdlib.h>

#include "elem.hpp"

class List {
  friend class Elem;  
public:
  Elem *mcurrent;
  Elem *mfirst;
  Elem *mlast;
  int mnumber;
    
  List(void);
  void Copy(List *list);
  Elem *get_mcurrent() {return mcurrent;}
  Elem *get_mfirst() {return mfirst; }  
  Elem *get_mlast() {return mlast;}  
  void Setmcurrent(Elem *n) {mcurrent = n;}
  virtual void Add(Elem * el);
  short Next(void);
  short Prev(void);
  short First(void);
  void DecMnumber() {mnumber--;}
  short get_mnumber() {return mnumber; }
};

#endif



